function X=LU_solve_gen(A,B)
% Funzione per risolvere l'equazione matriciale AX=B

%Input:
% A, B matrici 

%Output:
% X matrice soluzione del sistema AX=B


% L,U,P matrici restituite dal comando lu
[L,U,P]=lu(A);

% Prima versione
[m1,m2]=size(A);
if (m1~=m2)
    fprintf('Attenzione: A non  quadrata!\n');
end

[m,n]=size(B);
if (m~=m1)
    fprintf('Errore: la dimensione di B  sbagliata!\n')
end

for i=1:n
    Y(:,i)=L\(P*B(:,i));
    X(:,i)=U\Y(:,i);
    %oppure in un unico comando
    %X(:,i)=U\(L\(P*B(:,i)));
end

% Versione alternatva
% Y=L\(P*B);
% X=U\Y;
% %o semplicemente 
% %X=U\(L\(P*B));